import es, random, cfglib, playerlib

config = cfglib.AddonCFG(es.getAddonPath('headbuff') + "/headbuff.cfg")

config.text(' _   _                _______        __  __ ')
config.text('| | | |              | | ___ \      / _|/ _|')
config.text('| |_| | ___  __ _  __| | |_/ /_   _| |_| |_ ')
config.text('|  _  |/ _ \/ _` |/ _` | ___ \ | | |  _|  _|')
config.text('| | | |  __/ (_| | (_| | |_/ / |_| | | | |  ')
config.text('\_| |_/\___|\__,_|\__,_\____/ \__,_|_| |_|  ')
config.text(' ')
config.text('1 = enabled, 0 = disabled')
headbuff_enabled	= config.cvar('headbuff_enabled',	1, 'Enable/disable HeadBuff')
msg_enabled			= config.cvar('msg_enabled',		1, 'Enable/disable the message sent when a player gets a buff')
health_buff			= config.cvar('health_buff',		1, 'Enable/disable the health buff')
armor_buff			= config.cvar('armor_buff',			1, 'Enable/disable the armor buff')
ammo_buff			= config.cvar('ammo_buff',			1, 'Enable/disable the ammo buff')
speed_buff			= config.cvar('speed_buff',			1, 'Enable/disable the speed buff')
gravity_buff		= config.cvar('gravity_buff',		1, 'Enable/disable the gravity buff')
cash_buff			= config.cvar('cash_buff',			1, 'Enable/disable the cash buff')

config.text(' ')

health_amount		= config.cvar('health_amount',		30, 'How much health should be given by the health buff?')
armor_amount		= config.cvar('armor_amount',		50, 'How much armor should be given by the armor buff?')
ammo_amount			= config.cvar('ammo_amount',		50, 'How much ammo should be given by the ammo buff?')
speed_amount		= config.cvar('speed_amount',		2.0, 'Which speed should be given by the speed buff?')
gravity_amount		= config.cvar('gravity_amount',		0.5, 'Which gravity should be given by the gravity buff?')
cash_amount			= config.cvar('cash_amount',		2000, 'How much cash should be given by the cash buff?')

config.text(' ')
config.text(' ')
default_speed		= config.cvar('default_speed',		1, 'What is the default server speed?')
default_gravity		= config.cvar('default_gravity',	1, "What is the default server gravity? It's not the same as sv_gravity, '1' is normal")

config.write()

info = es.AddonInfo()
info.name			= 'HeadBuff'
info.version		= '1.2'
info.author			= 'Fault aka Immortal, Steam - Faultx'
info.basename		= 'headbuff'
info.description	= 'If a player gets a headshot, he is rewarded with a random buff'

es.ServerVar(info.basename, info.version, info.description).makepublic()

buffs = {
        'health':health_amount,
        'armor':armor_amount,
        'ammo':ammo_amount,
        'speed':speed_amount,
        'gravity':gravity_amount,
		'cash':cash_amount
        } 

def load():
	config.execute()
	if health_buff == 0:
		del buffs['health']
	if armor_buff == 0:
		del buffs['armor']
	if ammo_buff == 0:
		del buffs['ammo']
	if speed_buff == 0:
		del buffs['speed']
	if gravity_buff == 0:
		del buffs['gravity']
	if cash_buff == 0:
		del buffs['cash']
	
def player_death(ev):
	if headbuff_enabled:
		if ev['attacker'] and int(ev['headshot']):
			player = playerlib.getPlayer(ev['attacker'])
				
			buff = random.choice([x for x in buffs])
			if buff == 'health':
				player.health += buffs[buff]
			elif buff == 'armor':
				player.armor += buffs[buff]
			elif buff == 'cash':
				player.cash += buffs[buff]
			elif buff == 'ammo':
				if player.getPrimary():
					player.ammo.primary += buffs[buff]
					#player.add('ammo', (player.getPrimary(), buffs[buff]))
				if player.getSecondary():
					player.ammo.secondary += buffs[buff]
					#player.add('ammo', (player.getSecondary(), buffs[buff]))
			elif buff == 'gravity':
				es.server.queuecmd('est_setgravity %s %s'%(ev['attacker'],buffs[buff]))
			elif buff == 'speed':
				player.speed = buffs[buff]
			if msg_enabled:
				es.msg("#multi", "#green HeadBuff: #lightgreen%s #defaulthas received a %s buff (%s) for making a headshot" % (player.name, buff, buffs[buff]))

def player_spawn(ev):
	playerlib.getPlayer(ev['userid']).set('speed', default_speed)
	es.server.queuecmd('est_setgravity %s %s'%(ev['userid'],default_gravity))